/*

Files     	: ChangeDeviceID.ino
Version 	: 1.0
Date     	: 2012/11/09
Description	:
History		:

    1. Date			: 2012/11/09
       Author		: John Zhong@SimplyTronics
       Modification	: Create

*/

/* 
/////////////////////[ How to use this code to set DeviceID and PSS ]////////////////////////////
  1) change the ID value below "#define ID (0)"(If you are testing our demo, 
     then set them according to our device ID table)
  2) Compile and download to your Arduino,with the module connected to Serial Tx Pin(P1),
     if the ID and PSS is set successfully, the module will turn to green after about 5 seconds 
///////////////////////////////////////////////////////////////////////////////////////////////////
*/


///////////////////////////////////[ Only this one need to be changed ]//////////////////
#define ID (16)        /* Please change the ID you need for 4 module please set to 0/1/16/17 for each module*/
/////////////////////////////////////////////////////////////////////////////////////
#define PSS (15)      /* RSS = (PSS + 1) * 8 = 128,  Real Screen Size = (PSS + 1) * 8 */



/* You don't need to read to code below */
































#define BOUND_SX ((ID%(PSS+1))*8)
#define BOUND_SY ((ID/(PSS+1))*8)
#define BOUND_EX (BOUND_SX+7)
#define BOUND_EY (BOUND_SY+7)


#define    RGB_LED_MATRIX_UPDATE_SCREEN                   (0x00)

#define    RGB_LED_MATRIX_SET_POINTER_X                   (0x03)
#define    RGB_LED_MATRIX_SET_POINTER_Y                   (0x04)
#define    RGB_LED_MATRIX_SEND_DATA                      (0x05)
#define    RGB_LED_MATRIX_SET_WINDOW_BOUND_START_X         (0x06)           // NOTICE: AFTER SET THE WINDOWS BOUND, THE POINTERX AND POINTERY
#define    RGB_LED_MATRIX_SET_WINDOW_BOUND_START_Y         (0x07)           //         WILL POINT TO WINDOWS BOUND START X AND START Y AUTOMATIC
#define    RGB_LED_MATRIX_SET_WINDOW_BOUND_END_X           (0x08)           //
#define    RGB_LED_MATRIX_SET_WINDOW_BOUND_END_Y           (0x09)          //
#define    RGB_LED_MATRIX_FILL_GDRAM                     (0x0C)         // FILL THE GDRAM WITH DATA(USER DEFINED) TXCMD(#define    RGB_LED_MATRIX_FILLGDRAM, (0x01)

#define    RGB_LED_MATRIX_RESET                         (0xA0)
#define    RGB_LED_MATRIX_CHANGE_SCREEN_SIZE              (0xA8)
#define    RGB_LED_MATRIX_CHANGE_DEVICEID                (0xAA)


struct header_st
{
	byte str[4];
	byte cmd;
	union data_value_union
	{
		long bit_32;
		byte bit_8[4];
	} data_value;
} txPacket;

void tx_data_packet(void)
{
  	Serial.write(txPacket.str, 4);
	Serial.write(txPacket.cmd);
	Serial.write(txPacket.data_value.bit_8[3]);
	Serial.write(txPacket.data_value.bit_8[2]);
	Serial.write(txPacket.data_value.bit_8[1]);
	Serial.write(txPacket.data_value.bit_8[0]);
}


void setup(void)
{
        long index = 0;  
        long green = 0x0000FF00;
        long red   = 0x0000FF00;      
	Serial.begin(19200);
	txPacket.str[0] = 'P';
	txPacket.str[1] = 'M';
	txPacket.str[2] = 'T';
	txPacket.str[3] = 'X';
	txPacket.cmd = 0;
	txPacket.data_value.bit_32 = 0;	
	delay(2000);

	txPacket.cmd = RGB_LED_MATRIX_CHANGE_DEVICEID;
	txPacket.data_value.bit_32 = ID;
	tx_data_packet();
        delay(100);
        txPacket.cmd = RGB_LED_MATRIX_CHANGE_SCREEN_SIZE;
	txPacket.data_value.bit_32 = PSS;
	tx_data_packet();
        delay(100);
        
	txPacket.cmd = RGB_LED_MATRIX_CHANGE_DEVICEID;
	txPacket.data_value.bit_32 = ID;
	tx_data_packet();
        delay(100);
        txPacket.cmd = RGB_LED_MATRIX_CHANGE_SCREEN_SIZE;
	txPacket.data_value.bit_32 = PSS;
	tx_data_packet();
        delay(100);
        
        txPacket.cmd =  RGB_LED_MATRIX_RESET;
	txPacket.data_value.bit_32 = 0x00;
	tx_data_packet();
        delay(3000);
        
        txPacket.cmd =  RGB_LED_MATRIX_FILL_GDRAM;
	txPacket.data_value.bit_32 = 0x000000FF;
	tx_data_packet();

        
        txPacket.cmd =  RGB_LED_MATRIX_SET_WINDOW_BOUND_START_X;
	txPacket.data_value.bit_32 = BOUND_SX;
	tx_data_packet();

        txPacket.cmd =  RGB_LED_MATRIX_SET_WINDOW_BOUND_START_Y;
	txPacket.data_value.bit_32 = BOUND_SY;
	tx_data_packet();

        
        txPacket.cmd =  RGB_LED_MATRIX_SET_WINDOW_BOUND_END_X;
	txPacket.data_value.bit_32 = BOUND_EX;
	tx_data_packet();

        txPacket.cmd =  RGB_LED_MATRIX_SET_WINDOW_BOUND_END_Y;
	txPacket.data_value.bit_32 = BOUND_EY;
	tx_data_packet();
 

        txPacket.cmd =  RGB_LED_MATRIX_SET_POINTER_X ;
	txPacket.data_value.bit_32 = BOUND_SX;
	tx_data_packet();
        
        txPacket.cmd =  RGB_LED_MATRIX_SET_POINTER_Y;
	txPacket.data_value.bit_32 = BOUND_SY;
	tx_data_packet();



        txPacket.cmd =  RGB_LED_MATRIX_FILL_GDRAM;
	txPacket.data_value.bit_32 = red;
	tx_data_packet();
        
        txPacket.cmd =  RGB_LED_MATRIX_SEND_DATA;
	txPacket.data_value.bit_32 = 8 * 8 * 3;
	tx_data_packet();
       
       for(index = 0; index < 8*8; index++)
       {
	  Serial.write(green);
	  Serial.write(green>>8);
	  Serial.write(green>>16);        
        } 
        
        txPacket.cmd =  RGB_LED_MATRIX_UPDATE_SCREEN;
	txPacket.data_value.bit_32 = 0;
	tx_data_packet();

}

	
void loop(void)
{
	
}
