/*

Files     	: simple_test.ino
Version 	: 1.0
Date     	: 2012/08/15
Description	:
History		:

    1. Date			: 2012/08/15
       Author		: John Zhong@SimplyTronics
       Modification	: Create
	   

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


#define    RGB_LED_MATRIX_UPDATE_SCREEN                   (0x00)

#define    RGB_LED_MATRIX_SET_POINTER_X                   (0x03)
#define    RGB_LED_MATRIX_SET_POINTER_Y                   (0x04)
#define    RGB_LED_MATRIX_SEND_DATA                      (0x05)
#define    RGB_LED_MATRIX_SET_WINDOW_BOUND_START_X         (0x06)           // NOTICE: AFTER SET THE WINDOWS BOUND, THE POINTERX AND POINTERY
#define    RGB_LED_MATRIX_SET_WINDOW_BOUND_START_Y         (0x07)           //         WILL POINT TO WINDOWS BOUND START X AND START Y AUTOMATIC
#define    RGB_LED_MATRIX_SET_WINDOW_BOUND_END_X           (0x08)           //
#define    RGB_LED_MATRIX_SET_WINDOW_BOUND_END_Y           (0x09)          //
#define    RGB_LED_MATRIX_COPY_2_BXGDRAM                  (0x0A)
#define    RGB_LED_MATRIX_DISPLAY_BXGDRAM                (0x0B)
#define    RGB_LED_MATRIX_FILL_GDRAM                     (0x0C)         // FILL THE GDRAM WITH DATA(USER DEFINED) TXCMD(#define    RGB_LED_MATRIX_FILLGDRAM, (0x01)
/*
#define    RGB_LED_MATRIX_ROLLL_EFT                      (0x0D)
#define    RGB_LED_MATRIX_ROLL_RIGHT                     (0x0E)
#define    RGB_LED_MATRIX_ROLL_UP                        (0x0F)
#define    RGB_LED_MATRIX_ROLL_DOWN                      (0x10)
*/

#define    RGB_LED_MATRIX_SET_FOREGROUND_COLOR            (0x11)
#define    RGB_LED_MATRIX_SET_BACKGROUND_COLOR            (0x12)
#define    RGB_LED_MATRIX_DISPLAY_CHAR_0508               (0x13)
#define    RGB_LED_MATRIX_DISPLAY_CHAR_0816               (0x14)

#define    RGB_LED_MATRIX_DISPLAY_CHAR_0508_NBG            (0x15)             // NBG STAND FOR NO BACKGROUND
#define    RGB_LED_MATRIX_DISPLAY_CHAR_0816_NBG            (0x16)              // IF YOU WANT TO CLEAR THESE CHARACTER IN THE MATRIX PLEASE USE THE COMMAND #define    RGB_LED_MATRIX_DISPLAYBXGDRAM(  ) ABOVE
#define    RGB_LED_MATRIX_DISPLAY_PROPELLER_HAT           (0x17)
#define    RGB_LED_MATRIX_DISPLAY_PROPELLER_HAT_NBG        (0x18)
#define    RGB_LED_MATRIX_DISPLAY_PARALLAX_LOGO           (0x19)
#define    RGB_LED_MATRIX_DISPLAY_PARALLAX_LOGO_NBG        (0x1A)
#define    RGB_LED_MATRIX_DISPLAY_CUSTOMER_BMP1           (0x1B)
#define    RGB_LED_MATRIX_DISPLAY_CUSTOMER_BMP2           (0x1C)
#define    RGB_LED_MATRIX_DRAW_DOT                       (0x1D)

#define    RGB_LED_MATRIX_SET_LINE_END_X                   (0x1E)
#define    RGB_LED_MATRIX_SET_LINE_END_Y                   (0x1F)
#define    RGB_LED_MATRIX_DRAW_LINE                      (0x20)

#define    RGB_LED_MATRIX_SET_RADIUS                     (0x21)
#define    RGB_LED_MATRIX_DRAW_CIRCLE                    (0x22)

#define    RGB_LED_MATRIX_SAVE_PICTURE_EEPROM           (0x23)
#define    RGB_LED_MATRIX_LOAD_PICTURE_EEPROM           (0x24)


#define    RGB_LED_MATRIX_SCREEN_COLOR_INVERSE            (0x30)
#define    RGB_LED_MATRIX_SCREEN_OVERLAY                 (0x31)
#define    RGB_LED_MATRIX_SCREEN_MINUSLAY                (0x32)

#define    RGB_LED_MATRIX_RESET                         (0xA0)
#define    RGB_LED_MATRIX_SET_BAUDRATE                   (0xA1)
#define    RGB_LED_MATRIX_SET_MODE                       (0xA2)
#define    RGB_LED_MATRIX_GET_SCREEN_SIZE                 (0xA7)
#define    RGB_LED_MATRIX_CHANGE_SCREEN_SIZE              (0xA8)
#define    RGB_LED_MATRIX_GET_DEVICEID                   (0xA9)
#define    RGB_LED_MATRIX_CHANGE_DEVICEID                (0xAA)
#define    RGB_LED_MATRIX_GET_SYSTEM_CONFIGURATION        (0xAB)


struct header_st
{
	byte str[4];
	byte cmd;
	union data_value_union
	{
		long bit_32;
		byte bit_8[4];
	} data_value;
} txPacket;

long colordata = 0;



void tx_data_packet(void)
{


	Serial.write(txPacket.str, 4);
	Serial.write(txPacket.cmd);
	Serial.write(txPacket.data_value.bit_8[3]);
	Serial.write(txPacket.data_value.bit_8[2]);
	Serial.write(txPacket.data_value.bit_8[1]);
	Serial.write(txPacket.data_value.bit_8[0]);
}



void setup(void)
{
	Serial.begin(19200);
	txPacket.str[0] = 'P';
	txPacket.str[1] = 'M';
	txPacket.str[2] = 'T';
	txPacket.str[3] = 'X';
	txPacket.cmd = 0;
	txPacket.data_value.bit_32 = 0;	
	delay(1000);
}

	
void loop(void)
{

	txPacket.cmd = RGB_LED_MATRIX_FILL_GDRAM;
	txPacket.data_value.bit_32 = colordata;
	colordata += 20;
	tx_data_packet();
	
	
	
	txPacket.cmd = RGB_LED_MATRIX_UPDATE_SCREEN;
	txPacket.data_value.bit_32 = 0x00000000;
	tx_data_packet();
	
}
